From 0e8b5a4e7f386ba1fd0dcd6e632be0556a69f669 Mon Sep 17 00:00:00 2001
From: Luke Leighton <lkcl@lkcl.net>
Date: Mon, 13 Sep 2010 16:19:07 +0100
Subject: [PATCH 20/34] create provider inbox panel

---
 .../client/ProxiedWeb/gui/ProviderInboxPanel.py    |   77 ++++++++++++++++++++
 1 files changed, 77 insertions(+), 0 deletions(-)

diff --git a/gnumed/gnumed/client/ProxiedWeb/gui/ProviderInboxPanel.py b/gnumed/gnumed/client/ProxiedWeb/gui/ProviderInboxPanel.py
index e69de29..6359f43 100644
--- a/gnumed/gnumed/client/ProxiedWeb/gui/ProviderInboxPanel.py
+++ b/gnumed/gnumed/client/ProxiedWeb/gui/ProviderInboxPanel.py
@@ -0,0 +1,77 @@
+from pyjamas.builder.Builder import Builder, HTTPUILoader
+import GMWevents
+import Remote
+
+#======================================================
+class cProviderInboxPanel: 
+    def __init__(self):
+        self.pp = None
+        self.active_patient_id = None
+        self.TEXT_WAITING = "Waiting for response..."
+        HTTPUILoader(self).load("gnumedweb.xml") # calls onUILoaded when done
+
+    def onUILoaded(self, text):
+        self.b = Builder(text)
+        self.pp = self.b.createInstance("ProviderInbox", self)
+        GMWevents.login.addLoginListener(self)
+
+    def getPanel(self):
+        return self.pp
+
+    #--------------------------------------------------
+    def fill_grid(self, _messages):
+        show_active_only = self.pp.hpShow.rdbActive.getChecked()
+        if show_active_only and self.active_patient_id:
+            messages = []
+            for item in _messages:
+                if item.pk_patient == self.active_patient_id:
+                    messages.append(item)
+        else:
+            messages = _messages
+                
+        grid = self.pp.grid
+        grid.resize(1, 1+len(messages))
+        for (row, item) in enumerate(messages):
+            grid.setHTML(row+1, 1, str(item.received_when))
+            grid.setHTML(row+1, 2, item.category)
+            grid.setHTML(row+1, 3, item.type)
+            grid.setHTML(row+1, 4, item.comment)
+
+    #--------------------------------------------------
+    def onPatientSelected(self, patient_info):
+        self.active_patient_id = patient_info.
+        Remote.svc.get_provider_inbox_data(self)
+
+    #--------------------------------------------------
+    def onLogin(self, sender, username, logged_in):
+        self.logged_in = logged_in
+        Remote.svc.get_provider_inbox_data(self)
+
+    #--------------------------------------------------
+    def onRemoteResponse(self, response, request_info):
+        method = request_info.method
+
+        if method == 'get_provider_inbox_data':
+            self.fill_grid(response)
+
+    #--------------------------------------------------
+    def onRemoteError(self, code, errobj, request_info):
+        # onRemoteError gets the HTTP error code or 0 and
+        # errobj is an jsonrpc 2.0 error dict:
+        #     {
+        #       'code': jsonrpc-error-code (integer) ,
+        #       'message': jsonrpc-error-message (string) ,
+        #       'data' : extra-error-data
+        #     }
+        message = errobj['message']
+        if code != 0:
+            self.setStatus("HTTP error %d: %s" % 
+                                (code, message))
+        else:
+            code = errobj['code']
+            if message['message'] == 'Cannot request login parameters.':
+                self.setStatus("You need to log in first")
+            else:
+                self.setStatus("JSONRPC Error %s: %s" %
+                                (code, message))
+
-- 
1.7.1

